﻿#ifndef HCSDKINTERDEF_H
#define HCSDKINTERDEF_H

/*!
 *  用于统一定义命令字符串
 *  只在cpp文件包含即可.
 * 命名空间便于用户使用方便，字符串仍然需要唯一.
 * 这个头文件可以进行扩展。把发送的消息指向的URL进行记录.
 */
#define URL_get "get"
#define URL_post "post"
#define URL_put "put"
#define URL_delete "delete"
namespace HCSDK {
namespace TRANS {
    const static char *  DIRECTMESSAGE = "directMessage";
    const static char *  STATUS = "status";
    const static char *  SERVERSTATUS_CONNECTED="serverstatus_connected";
    const static char *  SERVERSTATUS_DISCONNECTD="serverstatus_disconnectd";
    const static char *  SERVERSTATUS_CONNECTING="serverstatus_connecting";
    const static char *  LOGINSTATUS_FAILED="loginStatus_failed";
    const static char *  LOGINSTATUS_OK="loginstatus_ok";//{userid,""}
        const static char *  SAML_GETINFO="trans_samllogininfo";
    //getupdateinfo data  { }
    const static char *  GETUPDATEINFO="update_getsoftwareinfo";
    const static char *  GETPROVISION="update_getprovision";

    const static char *  TEXTMESSAGE_TYPE="textmessage_type";
    const static char *  TEXTMESSAGE_PROCESS="textmessage_process";
    const static char *  TEXTMESSAGE_USERMESSAGE="textmessage_usermessage";
    const static char *  PROCESS_INTERNAL_INFO="process_internal_info";
    const static char *  PROCESS_INTERNAL_LOG="process_internal_log";


    //===================用户命令=================
}
namespace HCHANDLER {
const static char * CONFCMD="confcmd";
}
namespace  ROCKETID{
const static char * ID_CHAT_LOGIN="chat_method_login";
const static char * ID_SUBSCRIBE_ALL="suball_";
}

//概述基本的参数和网页 域名/apidoc/保持一直。
//把对方需要的参数 转换成json 包括 网址里面的参数和 body里面的参数。
//返回的是原始的result的filed里面的信息。
//通知
namespace IM {
namespace USER {
//服务器端获取通讯录.{"appid",""}
const static char *  CREATEENCRYPTESDK ="user_createEncryptoSDK";//);//
const static char *  USERLIST ="user_addressBookList";//);//服务器端获取通讯录.{"userid",""}
//用户分组组的列表。分组列表.
const static char *   SETLIST ="user_set_list";//);.{"userid",""}
//付费相关{"userid",""}
const static char *   GETPAYACCESSTOKEN ="user_getPayAccessToken";//);
//获取加密的信息{"client_id":"asdf","userid","asdf"}
const static char * GETENCRYPTOAUTHCODE= "user_getEncryptAuthCode";
//简略用户信息
const static char *   BRIEFINFO ="user_breifinfo";//{"keyword":""} 用户的 用户名,手机号,邮箱等.
//详细用户信息
const static char *   DETAILINFO ="userinfo_detail";//{"userid":""} //用户的userid
//申请添加好友.
//{"receiveUserId":"String",	"applyUserId" : "String"	,"requestDetail": "String"	};
//    被申请人ID.      申请人 ID.             申请信息.
const static char *   ADDFRIENDS ="user_addFriends";//
//相应添加我位好友的操作.
//{"receiveUserId":"",applyUserId:"", "status":"agree"}; status: agree 同意 deny 拒绝  applying 申请中
const static char *    ANSWERADDME ="user_answerAddMe";//
//添加好友的推送: 需要进行说明记录
//登录的时候获取都谁加我为好友。决定是否添加.
const static char *  GETADDMELIST ="user_getAddMeList";//);.{"userid",""}

const static char *  DELFRIENDS ="user_delFriends";//{"myid":"myid","deleteid":"deleteid"}
//删除申请
const static char *  DELREQUEST ="user_delRequest";//{"applicationId":""}
//修改好友备注
const static char *  SETFRIENDSNOTE ="user_setFriendsNote";//.{"myid":"","friendid":"好友ID","name":"要修改的名字"}
//------好友分组管理
//设置组的顺序  {"myid":"","setid":"","order":1}  order int类型
const static char *  SET_ORDER ="user_addressClassfication_order";//
//添加组.
const static char *  SEt_ADD ="user_addressClassfication_add";//{"myid":"","name":""}
//修改组的名称 //{"myid":"","setid":"","name":""}
const static char *  SET_RENAME ="user_addressClassfication_updateName";
//删除组//{"myid":"","setid":""}
const static char *  SET_DEL ="user_addressClassfication_del";
//用于单独的获取某个组的成员的接口。用户自己分类的组.
const static char *  SET_MEMBERLIST ="user_addressClassfication_memberList";//{"myid":"","setid":""}
//移动组成员
const static char *  SET_MOVE ="user_addressClassfication_move";//{"myid":"","setid":"","otherid":""}
//修改密码
const static char *  CHANGEMYPASSWORD ="user_changeMyPassword";//{"myid":"","setid":""}
//修改自己的头像
const static char *  UPDATEAVATARWEBSOCKET ="user_updateAvatarWebsocket";//const QString & path);
//=========企业通讯录相关
//删除企业关系{"myid":"","otherid":""}
const static char *    DELETEEnterpriseContact = "Enteruser_DeleteUserUserEnterprisecontactContact";
//增加企业关系{"myid":"","otherid":"","setid":""}
const static char *    ADDEnterpriseContact = "Enteruser_ADDUserUserEnterprisecontactContact";
//{"departmentid",""}  可选
const static char *    DEPARTMENT = "Enteruser_departmentquery";
//没有参数
const static char *    COMMPNYINFO = "Enteruser_companyinfo";
//企业用户信息　 参数｛"global":""｝
const static char *    COMMPNYUSERINFO = "Enteruser_companyuserinfo";

}

namespace GROUP {
//加入群组---
const static char *  GETROOMBYIDS = "group_getRoomByIds";//{和网页一致}

const static char *  JOIN = "group_joinChannel";//{"myid":"","groupid":""} 第一期屏蔽了主动加群
//暂时没有使用,按照文档写的.
const static char *  GETROOMBYTYPEANDNAME = "group_getRoomByTypeAndName";//第一期没有实现 {"myid":"","setid":""}
//离开群组
const static char *  LEAVE = "group_Leave";//{"groupid":""}
//创建频道公开的===第一次不使用
const static char *  CREATEPUBLICCHANNEL = "group_createChannel";//{"name":"","memebers":["a","b","c"]}
//创建私有群  第一期用这个
//{"name":"","setid","默认的分组.","memebers":["a","b","c"]}
const static char *  CREATEPRIVATE = "group_CreatePrivate";
//删除群组.
const static char *  GROUPDELETE = "group_Delete";//{"groupid":""}
//更改群组的名字
const static char *  CHANGENAME = "group_changeChannelName";//{"groupid":"","name":""}
//更新群组的公告
const static char *  UPDTATEANNONCE = "group_UpdtateAnnonce";//  {"groupid":"","roomAnnouncement":""}
//邀请其他人加入群
const static char *  INVITEOTHER = "group_inviteOther";// {"groupid":"","memebers":["a","b","c"]}
//把人踢出群
const static char *  KICKPERSONS = "group_kickPersons";//{"groupid":"","memebers":["a","b","c"]}
//群组信息更新.暂时支持更新name topic 和 description.=== 此接口不使用
const static char *  UPDATECHANNELINFO = "group_updateChannelInfo";
//获取群的详情
const static char *  GETDETAILS = "group_Getdetails";//{"groupid":""}
//设置群是否加密
const static char *  GROUPENCRYPTED = "group_encrypted";//{"groupid":"","encrypted":true / fasle}
//设置群的邀请方式.
const static char *  SURPASSSETENROLLMENTTYPE = "group_SurpassSetEnrollmentType";//{"groupid":"","type":""}
//获取群的角色
const static char *  GETOWNER = "group_GetOwner";//{"groupid":""}
//更改群的owner
const static char *  CHANGEOWNER = "group_ChangeOwner";//{"groupid":"","newOwner":""}
//获取群成员
const static char *  GETUSEROFROOM = "group_getuserOfroom";//{"groupid":"" }
//handle开头的处理经过服务器封装的restful的数据. 群的列表 和 群的分组结合使用。有些分组可能没有成员。
const static char *  CONTACTLIST = "group_contactlist";//);  {"myid":""}
//群的分组.
const static char *   SETLIST = "group_setlist";//); {"myid":"" }
//添加分组.
const static char *   SETADD = "group_setadd";//{"myid":"","name":""}
//删除分组.
const static char *   SETDEL = "group_setdel";// {"myid":"","setid","" }
//修改分组名称
const static char *   SETRENAME = "group_setreName";//{"myid":"","setid":"","name":"" }
//修改分组排序 order是int类型.
const static char *   SETCHANGEORDER = "group_setchangeOrder";//{"myid":"","setid":"","order":1}
//修改群所属的分组.
const static char *   SETMOVE = "group_setMove";////{"myid":"","setid":"","groupid":"" }
}
namespace CHAT {
const static char *  CREATEDIRECTROOM="chat_creatDirectRoom";//{"_id",""}  _id应该是用户id
//发送消息
//{
// "rid","" //roomid
//"encrypto":true,false, //是否加密
//"msgobj":msgobj
//  } msgobj是个json对象如下:
//    QJsonObject msgobj;
//    msgobj.insert("_id", msg.getMsgId());
//    msgobj.insert("rid",msg.getSessionId());
//    msgobj.insert("msg",msg.getMsgContent());
//    msgobj.insert("msgType",msg.getMsgType());
//    msgobj.insert("userData",msg.getUserData());
//    QJsonObject uObj;
//    uObj.insert("senderName",msg.getSenderName());
//    uObj.insert("senderHeadUrl",msg.getSenderHeadUrl());
//    msgobj.insert("u",uObj);
const static char *  SENDMESSAGE="chat_sendMessage";//const ChatMsgData &msg);
//撤回消息 //{"msgobj":msgobj}
//        msgobj.insert("_id", msgId);
//        msgobj.insert("rid", roomId);
//        msgobj.insert("userData", "");
const static char *  WITHDRAWMESSAGE="chat_withdrawMessage";//const QString &msgId, const QString &roomId);
//确认消息
//        msgobj.insert("lsMsgSeq", lsMsgSeq);
//        msgobj.insert("lsMsgTs", lsMsgTs);
//        msgobj.insert("rid", roomId);
const static char *  CONFIRMMESSAGE="chat_confirmMessage";//const qint64 &lsMsgTs, const qint64 &lsMsgSeq, const QString &roomId);
//{"msgobj":msgobj}  空的msgobj jsonobject
const static char *  GETROOMLIST="chat_getRoomList";//);
//        QJsonObject msgobj;
//        msgobj.insert("rid", roomId);
//        QJsonArray rangeArray;
//        rangeArray.append(beginSeq);
//        rangeArray.append(endSeq);
//        msgobj.insert("seqRange",rangeArray);
const static char *  LOADMISSEDMESSAGE="chat_loadMissedMessage";//const QString &roomId, const qint64 &beginSeq, const qint64 &endSeq);
//        QJsonObject msgobj;
//         msgobj.insert("lsMsgTs",lsMsgTs);
const static char *  GETOFFLINEMESSAGE="chat_getOfflineMessage";//const qint64 &lsMsgTs);

//        QJsonObject msgobj;
//         msgobj.insert("lsMsgTs",lsMsgTs);
const static char *  GETOFFLINENOTICE="chat_getOfflineNotice";//const qint64 &lsMsgTs);
//        QJsonObject msgobj;
//        msgobj.insert("rid",roomId);
//        QJsonObject profileObj;
//        profileObj.insert("key",key);
//        profileObj.insert("value",value);
//        msgobj.insert("profile",profileObj);
//con//key 属性名称 top/mute/hide/done/star ";//置顶/免打扰/隐藏/已完成/星标)
const static char *  SETROOMPROFILE="chat_setRoomProfile";
//        QJsonObject msgobj;
//         msgobj.insert("rid",roomId);
const static char *  GETROOMINFO="chat_getRoomInfo";//const QString &roomId);
//key要存在可以保持内容为空.
//文件上传
//发送{"roomID":"","filePath":"","msgID":"","encryped":true/false}
//进度字段在status 是1的时候才有.
//接收 {"status":0,1,2,"msgID":"", "fileID":"","filekey":"","now":123,"total":1234}  //status 0,成功  1,进度，2失败
const static char *  UPLOADFILE = "chat_uploadfile";//
//文件下载:
//发送{"fileID","","filePath":"","msgID":"","filekey":""}
//进度字段在status 是1的时候才有.
//接收 {"status":0,1,2,"msgID":"", "localpath":"","now":123,"total":1234}//status 0,成功  1,进度，2失败
const static char *  DOWNLOADFILE = "chat_downloadfile";//
//缩略图下载:没有进度
//发送{"fileID","","filePath":"","msgID":""}
//接收 {"status":0,2"msgID":"", "localpath":""}//status 0,成功  1,进度，2失败
const static char *  DOWNLOADThumbnailPIC= "chat_downloadThumbnailPic";//

}
}
namespace CONF {
//会议室管理.
const static char * ROOMSEARCH ="confRoomsearch";//{"userid":""}跟自己相关的room
const static char * ROOMOWNER ="confRoomowner";//{"userid":""}拥有的room
const static char * ROOMINFO ="confRoominfo";//{"roomid":""}
const static char * ROOMUPDATE ="confRoomupdate";//{"roomid":"","payload":""}
const static char * ROOMCREATE ="confRoomcreate";//{"roomid":"","payload":""}
const static char * ROOMDELETE ="confRoomdelete";//{"roomid":""}


//会议管理
const static char * PING ="confping";//{"conferenceid":"","externaldeviceid":""}
const static char * SEARCH ="confsearch";//{"startTime":int64,"endTime":int64,"participantID",""}
const static char * INFO ="confinfo";//{"confid",""}
const static char * CREATE ="confcreate";//{"payload":"原来的json转成字符串HCConernce"}
const static char * UPDATE ="confupdate";//{"payload":"原来的json转成字符串HCConernce"}
const static char * CONFDELETE ="confdelete";//{"confid",""}const static char * ="
const static char * CALENDARPREVIEW = "confCalendarPreview"; //{"participantid":"", "starttime":, "endtime"}
const static char * CHANGEINVITEMODE = "confChangeinvitemode"; //会议改变邀请模式 {"conferenceid":"", "invitemode":0,1,2}


//会议控制:
const static char * JOIN ="confControljoin";//{"dialnumber":"","passcode":""}
const static char * TERMINATE ="confControlterminate";//{"confid":""}
const static char * ADDPARTICIPANT ="confControlAddParticipant";//{"confid":"","participants":[{"userId":"","externalId":""}]}
const static char * LAYOUT ="confControllayout";//{"confid":"","layout":""}
const static char * MUTEAUDIO ="confControlmuteaudio";//{"confid":"","guid":"","mute":bool}
const static char * MUTEAUDIOLOCAL ="confControlmuteaudiolocal";//{"confid":"","externaldeviceid":"","mute":bool}
const static char * ADMINALLOWUNMUTE ="confControladminallowunmute";//{"confid":"","allown":bool}
const static char * MUTEALL ="confControlmuteAll";//{"confid":"","mute":bool}
const static char * AUTHORITY ="confControlauthority";//{"confid":"","participantid":"","authority":bool}
const static char * HANDUP ="confControlhandup";//{"confid":"","guid":"","ishandup":bool}
const static char * CONTENTSHARE ="confControlcontentshare";//{"confid":"","guid":"","isOpen":bool}
const static char * ENDPOINTS ="confControlendpoints";//{"confid":""}
const static char * REFUSE ="confControlrefuse";////{"confid":"","participantid":""}
const static char * CONNECTIONSTATUS ="confControlconnectionstatus";//{"confid":"","externaldeviceid":"","status":"online或者offline"}
//const static char * ="confControlconnectiononline";//没有使用
//const static char * ="confControlconnectionoffline";//没有使用


// 入会/离开会议
const static char * STARTCONF ="startconf";// {"dialnum":"内部会议号", "ext_dialnum":"外部会议号", "passcode":""}
const static char * LEAVECONF ="leaveconf";//{}


//会议通知:
const static char * NOTIFY ="confnotify";

}
namespace EVENT {
const static char * CONFMANAGEREVENT = "confmanager_event";

}
//信令名称 'REGISTER｜UNREGISTER｜INVITE｜CONNECTING｜ACCEPTED｜ACK｜RINGING｜BYE｜OK｜ERROR'


namespace CONFSIGNAL {
//和服务器保持一致
    namespace METHOD {
        const static char * REGISTER   = "REGISTER";
        const static char * UNREGISTER = "UNREGISTER";
        const static char * INVITE     = "INVITE";
        const static char * CONNECTING = "CONNECTING";
        const static char * ACCEPTED   = "ACCEPTED";
        const static char * ACK        = "ACK";
        const static char * RINGING    = "RINGING";
        const static char * BYE    = "BYE";
        const static char * OK    = "OK";
        const static char * OPERROR   = "ERROR";

    }
//    namespace SIGNALID {
//        const static char * REGISTER   ="confsignal_REGISTER";//这个是命令
//        const static char * UNREGISTER ="confsignal_UNREGISTER";
//        const static char * INVITE     ="confsignal_INVITE";
//        const static char * CONNECTING ="confsignal_CONNECTING";
//        const static char * ACCEPTED   ="confsignal_ACCEPTED";
//        const static char * ACK        ="confsignal_ACK";
//        const static char * RINGING    ="confsignal_RINGING";
//        const static char * OK    ="confsignal_OK";
//        const static char * BYE        ="confsignal_BYE";
//        const static char * ERROR      ="confsignal_ERROR";
//    }

}
enum HCTransType{
    serverstatus_type=100,
    serverstatus_connected,
    serverstatus_disconnectd,
    serverstatus_connecting,
    loginStatus_type=200,
    loginstatus_ok,
    textmessage_type=300,
    textmessage_process,
    textmessage_usermessage,
    HCBiztrans_end
};
enum BizCmdType{
    BizCMD_begin=1000
};
enum UserCmdType{
    USERCMD_begin=10000,
    USERCMD_conf_ping,  //{"conferenceid":"","externaldeviceid":""}

    //会议室管理.
    USERCMD_room_search ,//{"userid":""}跟自己相关的room
    USERCMD_room_owner ,//{"userid":""}拥有的room
    USERCMD_room_info ,//{"roomid":""}
    USERCMD_room_update ,//{"roomid":"","payload":""}
    USERCMD_room_create ,//{"roomid":"","payload":""}
    USERCMD_room_delete ,//{"roomid":""}
    USRECMD_room_end,

    //会议管理
    USERCMD_conf_search,//{"startTime":int64,"endTime":int64,"participantID",""}
    USERCMD_conf_info,//{"confid",""}
    USERCMD_conf_create,//{"payload":"原来的json转成字符串HCConernce"}
    USERCMD_conf_update,//{"payload":"原来的json转成字符串HCConernce"}
    USERCMD_conf_delete,//{"confid",""}
    USERCMD_conf_end,

    //会议控制:
    USERCMD_confControl_join,  //  { "dialnumber":"", "passcode":""}
    USERCMD_confControl_terminate,  //  { "confid":""}
    USERCMD_confControl_AddParticipant,//{"confid":"","participants":[{"userId":"","externalId":""} ]  }
    USERCMD_confControl_layout,    //  {"confid":"","layout":""  }
    USERCMD_confControl_muteaudio, //  {"confid":"","guid":"","mute":bool  }
    USERCMD_confControl_muteaudio_local,    //  {"confid":"","externaldeviceid":"","mute":bool  }
    USERCMD_confControl_adminallowunmute, //  {"confid":"","allown":bool  }
    USERCMD_confControl_muteAll,//  {"confid":"","mute":bool  }
    USERCMD_confControl_authority,      //  {"confid":"","participantid":"","authority":bool  }
    USERCMD_confControl_handup,//  {"confid":"","guid":"","ishandup":bool  }
    USERCMD_confControl_contentshare,//  {"confid":"","guid":"","isOpen":bool  }
    USERCMD_confControl_endpoints,     //{"confid":""}
    USERCMD_confControl_refuse,   //  //{"confid":"","participantid":""}
    USERCMD_confControl_connection_status,//{"confid":"","externaldeviceid":"","status":" online 或者 offline"}
    USERCMD_confControl_connection_online,//没有使用
    USERCMD_confControl_connection_offline,//没有使用
    usercmdall_end//结束
};

}
#endif // HCSDKINTERDEF_H
